"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toNativeLogCallback = exports.toNativeCallbackWithResponse = exports.toNativeCallback = void 0;
const ffi_napi_1 = require("@2060.io/ffi-napi");
const ref_napi_1 = require("@2060.io/ref-napi");
const alloc_1 = require("./alloc");
const primitives_1 = require("./primitives");
const toNativeCallback = (cb) => {
    const nativeCallback = (0, ffi_napi_1.Callback)(primitives_1.FFI_VOID, [primitives_1.FFI_CALLBACK_ID, primitives_1.FFI_ERROR_CODE], cb);
    const id = (0, alloc_1.allocateCallbackBuffer)(nativeCallback);
    return { nativeCallback, id };
};
exports.toNativeCallback = toNativeCallback;
const toNativeCallbackWithResponse = (cb, responseFfiType = primitives_1.FFI_STRING) => {
    const nativeCallback = (0, ffi_napi_1.Callback)(primitives_1.FFI_VOID, [primitives_1.FFI_CALLBACK_ID, primitives_1.FFI_ERROR_CODE, responseFfiType], cb);
    const id = (0, alloc_1.allocateCallbackBuffer)(nativeCallback);
    return { nativeCallback, id };
};
exports.toNativeCallbackWithResponse = toNativeCallbackWithResponse;
const toNativeLogCallback = (cb) => {
    const nativeCallback = (0, ffi_napi_1.Callback)(primitives_1.FFI_VOID, [(0, ref_napi_1.refType)(primitives_1.FFI_VOID), primitives_1.FFI_INT32, primitives_1.FFI_STRING, primitives_1.FFI_STRING, primitives_1.FFI_STRING, primitives_1.FFI_STRING, primitives_1.FFI_INT32], cb);
    const id = (0, alloc_1.allocateCallbackBuffer)(nativeCallback);
    return { nativeCallback, id };
};
exports.toNativeLogCallback = toNativeLogCallback;
//# sourceMappingURL=callback.js.map