import { ArcHandle, Jwk, Key, ScanHandle, SessionHandle, StoreHandle } from '@openwallet-foundation/askar-shared';
import type { ByteBufferStruct, SecretBufferStruct } from './structures';
export type Callback = (err: number) => void;
export type CallbackWithResponse = (err: number, response: string) => void;
type Argument = Record<string, unknown> | ArcHandle | StoreHandle | SessionHandle | ScanHandle | unknown[] | Date | Uint8Array | SerializedArgument | boolean | Jwk | Key;
type SerializedArgument = string | number | Callback | CallbackWithResponse | ArrayBuffer | typeof ByteBufferStruct | typeof SecretBufferStruct | Buffer;
export type SerializedOptions<Type> = Required<{
    [Property in keyof Type]: Type[Property] extends string ? string : Type[Property] extends number | boolean | Date | StoreHandle | SessionHandle | ScanHandle ? number : Type[Property] extends Record<string, unknown> | unknown[] ? string : Type[Property] extends Buffer | Uint8Array | Key | ArcHandle | Jwk ? Buffer : Type[Property] extends Callback ? Callback : Type[Property] extends CallbackWithResponse ? CallbackWithResponse : Type[Property] extends boolean | undefined ? number : Type[Property] extends unknown[] | undefined ? string : Type[Property] extends Record<string, unknown> | undefined ? string : Type[Property] extends Date | undefined ? number : Type[Property] extends string | undefined ? string : Type[Property] extends number | undefined ? number : Type[Property] extends Uint8Array | undefined ? Buffer : unknown;
}>;
declare const serializeArguments: <T extends Record<string, Argument> = Record<string, Argument>>(args: T) => SerializedOptions<T>;
export { serializeArguments };
